## blis 0.8.0

=== Makefile ===
#
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
# 
# Top-level makefile for libflame linear algebra library.
#
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        libs libblis \
        check-env check-env-mk check-env-fragments check-env-make-defs \
        flat-header flat-cblas-header \
        test \
        testblas blastest-f2c blastest-bin blastest-run \
        testsuite testsuite-bin \
        testsuite-run testsuite-run-fast testsuite-run-md testsuite-run-salt \
        testblis testblis-fast testblis-md testblis-salt \
        check checkblas \
        checkblis checkblis-fast checkblis-md checkblis-salt \
        install-headers install-libs install-lib-symlinks \
        showconfig \
        clean cleanmk cleanh cleanlib distclean \
        cleantest cleanblastest cleanblistest \
        changelog \
        install uninstall uninstall-old \
        uninstall-libs uninstall-lib-symlinks uninstall-headers \
        uninstall-old-libs uninstall-lib-symlinks uninstall-old-headers

#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - We don't need to define DIST_PATH, LIB_PATH, INC_PATH, or SHARE_PATH since
#   the defaults in common.mk (and config.mk) are designed to work with the
#   top-level Makefile.
#DIST_PATH  := .
#LIB_PATH    = ./lib/$(CONFIG_NAME)
#INC_PATH    = ./include/$(CONFIG_NAME)
#SHARE_PATH := .


#
# --- Include common makefile definitions --------------------------------------
#

# Define the name of the common makefile.
COMMON_MK_FILE    := common.mk

# Include the configuration file.
-include $(COMMON_MK_FILE)

# Detect whether we actually got the configuration file. If we didn't, then
# it is likely that the user has not yet generated it (via configure).
ifeq ($(strip $(COMMON_MK_INCLUDED)),yes)
COMMON_MK_PRESENT := yes
else
COMMON_MK_PRESENT := no
endif



#
# --- Main target variable definitions -----------------------------------------
#

# --- Object file paths ---

# Construct the base object file path for the current configuration.
BASE_OBJ_PATH          := ./$(OBJ_DIR)/$(CONFIG_NAME)

# Construct base object file paths corresponding to the four locations
# of source code.
BASE_OBJ_CONFIG_PATH   := $(BASE_OBJ_PATH)/$(CONFIG_DIR)
BASE_OBJ_FRAME_PATH    := $(BASE_OBJ_PATH)/$(FRAME_DIR)
BASE_OBJ_REFKERN_PATH  := $(BASE_OBJ_PATH)/$(REFKERN_DIR)
BASE_OBJ_KERNELS_PATH  := $(BASE_OBJ_PATH)/$(KERNELS_DIR)
BASE_OBJ_SANDBOX_PATH  := $(BASE_OBJ_PATH)/$(SANDBOX_DIR)

# --- Define install target names for static libraries ---

LIBBLIS_A_INST            := $(INSTALL_LIBDIR)/$(LIBBLIS_A)

# --- Define install target names for shared libraries ---

LIBBLIS_SO_INST           := $(INSTALL_LIBDIR)/$(LIBBLIS_SO)
LIBBLIS_SO_MAJ_INST       := $(INSTALL_LIBDIR)/$(LIBBLIS_SONAME)

ifeq ($(IS_WIN),yes)
# The 'install' target does not create symlinks for Windows builds, so we don't
# bother defining LIBBLIS_SO_MMB_INST.
LIBBLIS_SO_MMB_INST       :=
else
LIBBLIS_SO_MMB_INST       := $(INSTALL_LIBDIR)/$(LIBBLIS).$(LIBBLIS_SO_MMB_EXT)
endif

# --- Determine which libraries to build ---

MK_LIBS                   :=
MK_LIBS_INST              :=
MK_LIBS_SYML              :=

ifeq ($(MK_ENABLE_STATIC),yes)
MK_LIBS                   += $(LIBBLIS_A_PATH)
MK_LIBS_INST              += $(LIBBLIS_A_INST)
MK_LIBS_SYML              +=
endif
ifeq ($(MK_ENABLE_SHARED),yes)
MK_LIBS                   += $(LIBBLIS_SO_PATH) \
                             $(LIBBLIS_SO_MAJ_PATH)
MK_LIBS_INST              += $(LIBBLIS_SO_MMB_INST)
MK_LIBS_SYML              += $(LIBBLIS_SO_INST) \
                             $(LIBBLIS_SO_MAJ_INST)
endif

# Strip leading, internal, and trailing whitespace.
MK_LIBS_INST              := $(strip $(MK_LIBS_INST))
MK_LIBS_SYML              := $(strip $(MK_LIBS_SYML))

# --- Define install directory for headers ---

# Set the path to the subdirectory of the include installation directory.
MK_INCL_DIR_INST          := $(INSTALL_INCDIR)/blis

# --- Define install directory for public makefile fragments ---

# Set the path to the subdirectory of the share installation directory.
MK_SHARE_DIR_INST         := $(INSTALL_SHAREDIR)/blis



#
# --- Library object definitions -----------------------------------------------
#

# In this section, we will isolate the relevant source code filepaths and
# convert them to lists of object filepaths. Relevant source code falls into
# four categories: configuration source; architecture-specific kernel source;
# reference kernel source; and general framework source.

# $(call gen-obj-paths-from-src file_exts, src_files, base_src_path, base_obj_path)
gen-obj-paths-from-src = $(foreach ch, $(1), \
                             $(patsubst $(3)/%.$(ch), \
                                        $(4)/%.o, \
                                        $(filter %.$(ch), $(2)) ) )

# Generate object file paths for source code found in the sub-configuration
# directories.
MK_CONFIG_OBJS      := $(call gen-obj-paths-from-src,$(CONFIG_SRC_SUFS),$(MK_CONFIG_SRC),$(CONFIG_PATH),$(BASE_OBJ_CONFIG_PATH))

# Generate object file paths for architecture-specific kernel source code.
# We target only .c, .s, and .S files. Note that MK_KERNELS_SRC is already
# limited to the kernel source corresponding to the kernel sets in
# KERNEL_LIST. This is because the configure script only propogated makefile
# fragments into those specific kernel subdirectories.
MK_KERNELS_OBJS     := $(call gen-obj-paths-from-src,$(KERNELS_SRC_SUFS),$(MK_KERNELS_SRC),$(KERNELS_PATH),$(BASE_OBJ_KERNELS_PATH))

# Generate object file paths for reference kernels, with one set of object
# files for each sub-configuration in CONFIG_LIST. Note that due to the
# nuances of naming the reference kernel files, we can't use the function
# gen-obj-paths-from-src as we do above and below.
MK_REFKERN_C        := $(filter %.c, $(MK_REFKERN_SRC))
MK_REFKERN_OBJS     := $(foreach arch, $(CONFIG_LIST), \
                           $(patsubst $(REFKERN_PATH)/%_$(REFNM).c, \
                                 $(BASE_OBJ_REFKERN_PATH)/$(arch)/%_$(arch)_$(REFNM).o, \
                                 $(MK_REFKERN_C) \
                            ) \
                        )

# Generate object file paths for all of the portable framework source code.
MK_FRAME_OBJS       := $(call gen-obj-paths-from-src,$(FRAME_SRC_SUFS),$(MK_FRAME_SRC),$(FRAME_PATH),$(BASE_OBJ_FRAME_PATH))

# Generate object file paths for the sandbox source code. If a sandbox was not
# enabled a configure-time, this variable will we empty.
MK_SANDBOX_OBJS     := $(call gen-obj-paths-from-src,$(SANDBOX_SRC_SUFS),$(MK_SANDBOX_SRC),$(SANDBOX_PATH),$(BASE_OBJ_SANDBOX_PATH))

# Combine all of the object files into some readily-accessible variables.
MK_BLIS_OBJS        := $(MK_CONFIG_OBJS) \
                       $(MK_KERNELS_OBJS) \
                       $(MK_REFKERN_OBJS) \
                       $(MK_FRAME_OBJS) \
                       $(MK_SANDBOX_OBJS)

# Optionally filter out the BLAS and CBLAS compatibility layer object files.
# This is not actually necessary, since each affected file is guarded by C
# preprocessor macros, but it but prevents "empty" object files from being
# added into the library (and reduces compilation time).
BASE_OBJ_BLAS_PATH  := $(BASE_OBJ_FRAME_PATH)/compat
BASE_OBJ_CBLAS_PATH := $(BASE_OBJ_FRAME_PATH)/compat/cblas
ifeq ($(MK_ENABLE_CBLAS),no)
MK_BLIS_OBJS        := $(filter-out $(BASE_OBJ_CBLAS_PATH)/%.o, $(MK_BLIS_OBJS) )
endif
ifeq ($(MK_ENABLE_BLAS),no)
MK_BLIS_OBJS        := $(filter-out $(BASE_OBJ_BLAS_PATH)/%.o,  $(MK_BLIS_OBJS) )
endif



#
# --- Monolithic header definitions --------------------------------------------
#

# Define a list of headers to install. The default is to only install blis.h.
HEADERS_TO_INSTALL := $(BLIS_H_FLAT)

# If CBLAS is enabled, we also install cblas.h so the user does not need to
# change their source code to #include "blis.h" in order to access the CBLAS
# function prototypes and enums.
ifeq ($(MK_ENABLE_CBLAS),yes)
HEADERS_TO_INSTALL += $(CBLAS_H_FLAT)
endif

# If requested, include AMD's C++ template header files in the list of headers
# to install.
ifeq ($(INSTALL_HH),yes)
HEADERS_TO_INSTALL += $(wildcard $(VEND_CPP_PATH)/*.hh)
endif



#
# --- public makefile fragment definitions -------------------------------------
#

# Define a list of makefile fragments to install.
FRAGS_TO_INSTALL := $(CONFIG_MK_FILE) \
                    $(COMMON_MK_FILE)



#
# --- BLAS test drivers definitions --------------------------------------------
#

# The location of the BLAS test suite's input files.
BLASTEST_INPUT_PATH    := $(DIST_PATH)/$(BLASTEST_DIR)/input

# The location of the BLAS test suite object directory.
BASE_OBJ_BLASTEST_PATH := $(BASE_OBJ_PATH)/$(BLASTEST_DIR)

# The locations of the BLAS test suite source code (f2c and drivers).
BLASTEST_F2C_SRC_PATH  := $(DIST_PATH)/$(BLASTEST_DIR)/f2c
BLASTEST_DRV_SRC_PATH  := $(DIST_PATH)/$(BLASTEST_DIR)/src

# The paths to object files we will create (f2c and drivers).
BLASTEST_F2C_OBJS      := $(sort \
                          $(patsubst $(BLASTEST_F2C_SRC_PATH)/%.c, \
                                     $(BASE_OBJ_BLASTEST_PATH)/%.o, \
                                     $(wildcard $(BLASTEST_F2C_SRC_PATH)/*.c)) \
                           )

BLASTEST_DRV_OBJS      := $(sort \
                          $(patsubst $(BLASTEST_DRV_SRC_PATH)/%.c, \
                                     $(BASE_OBJ_BLASTEST_PATH)/%.o, \
                                     $(wildcard $(BLASTEST_DRV_SRC_PATH)/*.c)) \
                           )

# libf2c name and location.
BLASTEST_F2C_LIB_NAME  := libf2c.a
BLASTEST_F2C_LIB       := $(BASE_OBJ_BLASTEST_PATH)/$(BLASTEST_F2C_LIB_NAME)

# The base names of each driver source file (ie: filename minus suffix).
BLASTEST_DRV_BASES     := $(basename $(notdir $(BLASTEST_DRV_OBJS)))

# The binary executable driver names.
BLASTEST_DRV_BINS      := $(addsuffix .x,$(BLASTEST_DRV_BASES))
BLASTEST_DRV_BIN_PATHS := $(addprefix $(BASE_OBJ_BLASTEST_PATH)/,$(BLASTEST_DRV_BINS))

# Binary executable driver "run-" names
BLASTEST_DRV_BINS_R    := $(addprefix run-,$(BLASTEST_DRV_BASES))

# Filter level-1, level-2, and level-3 names to different variables.

=== test/Makefile ===
#
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#  Copyright (C) 2017 - 2020, Advanced Micro Devices, Inc.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
# 
# Makefile for standalone BLIS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        blis openblas atlas mkl \
        check-env check-env-mk check-lib \
        clean cleanx



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ..
LIB_PATH    = ../lib/$(CONFIG_NAME)
INC_PATH    = ../include/$(CONFIG_NAME)
SHARE_PATH := ..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- BLAS and LAPACK implementations ------------------------------------------
#

# BLIS library and header path. This is simply wherever it was installed.
#BLIS_LIB_PATH  := $(INSTALL_PREFIX)/lib
#BLIS_INC_PATH  := $(INSTALL_PREFIX)/include/blis

# BLIS library.
#BLIS_LIB       := $(BLIS_LIB_PATH)/libblis.a

# BLAS library path(s). This is where the BLAS libraries reside.
BLAS_LIB_PATH  := $(HOME)/flame/lib
#MKL_LIB_PATH   := /opt/apps/intel/13/composer_xe_2013.2.146/mkl/lib/intel64
#MKL_LIB_PATH   := $(HOME)/intel/mkl/lib/intel64
MKL_LIB_PATH   := $(HOME)/intel/mkl/lib/intel64

# OpenBLAS
OPENBLAS_LIB   := $(BLAS_LIB_PATH)/libopenblas.a

# MKL
MKL_LIB        := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_sequential \
                  -lpthread -lm -ldl


#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(patsubst $(TEST_SRC_PATH)/%.c, \
                             $(TEST_OBJ_PATH)/%.o, \
                             $(wildcard $(TEST_SRC_PATH)/*.c))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
#LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)



#
# --- Targets/rules ------------------------------------------------------------
#

# Define the operations we will test.
TEST_OPS := dotv axpyv \
            gemv ger hemv her her2 trmv trsv \
            gemm hemm herk her2k trmm trsm

# Optionally test gemmt, which some libraries might not implement.
ifeq ($(BUILD_GEMMT),yes)
TEST_OPS := $(TEST_OPS) gemmt
endif

# Define a function to create the executable names.
test-bins = $(foreach op, $(TEST_OPS), test_$(op)_$(1).x)

# Create the list of executables for each implementation.
TEST_BINS_BLIS     := $(call test-bins,blis)
TEST_BINS_OPENBLAS := $(call test-bins,openblas)
TEST_BINS_MKL      := $(call test-bins,mkl)


all: blis openblas mkl

blis: check-env $(TEST_BINS_BLIS)

openblas: check-env $(TEST_BINS_OPENBLAS)

mkl: check-env $(TEST_BINS_MKL)


# --Object file rules --

$(TEST_OBJ_PATH)/%.o: $(TEST_SRC_PATH)/%.c
	$(CC) $(CFLAGS) -c $< -o $@


test_%_openblas.o: test_%.c
	$(CC) $(CFLAGS) -DBLAS=\"openblas\" -c $< -o $@

test_%_mkl.o: test_%.c
	$(CC) $(CFLAGS) -DBLAS=\"mkl\" -c $< -o $@

test_%_blis.o: test_%.c
	$(CC) $(CFLAGS) -DBLIS -c $< -o $@


# -- Executable file rules --

# NOTE: For the BLAS test drivers, we place the BLAS libraries before BLIS
# on the link command line in case BLIS was configured with the BLAS
# compatibility layer. This prevents BLIS from inadvertently getting called
# for the BLAS routines we are trying to test with.

test_%_openblas.x: test_%_openblas.o $(LIBBLIS_LINK)
	$(LINKER) $<             $(OPENBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@

test_%_mkl.x: test_%_mkl.o $(LIBBLIS_LINK)
	$(LINKER) $<             $(MKL_LIB)      $(LIBBLIS_LINK) $(LDFLAGS) -o $@

test_%_blis.x: test_%_blis.o $(LIBBLIS_LINK)
	$(LINKER) $<                             $(LIBBLIS_LINK) $(LDFLAGS) -o $@


# -- Environment check rules --

check-env: check-lib

check-env-mk:
ifeq ($(CONFIG_MK_PRESENT),no)
	$(error Cannot proceed: config.mk not detected! Run configure first)
endif

check-lib: check-env-mk
ifeq ($(wildcard $(LIBBLIS_LINK)),)
	$(error Cannot proceed: BLIS library not yet built! Run make first)
endif


# -- Clean rules --

clean: cleanx

cleanx:
	- $(RM_F) *.o *.x

=== test/3/Makefile ===
#!/bin/bash
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#  Copyright (C) 2018, Advanced Micro Devices, Inc.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
#
# Makefile for standalone BLIS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        check-env check-env-mk check-lib \
        clean cleanx



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ../..
LIB_PATH    = ../../lib/$(CONFIG_NAME)
INC_PATH    = ../../include/$(CONFIG_NAME)
SHARE_PATH := ../..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- BLAS implementations -----------------------------------------------------
#

# BLAS library path(s). This is where the BLAS libraries reside.
HOME_LIB_PATH  := $(HOME)/flame/lib

# OpenBLAS
OPENBLAS_LIB   := $(HOME_LIB_PATH)/libopenblas.a
OPENBLASP_LIB  := $(HOME_LIB_PATH)/libopenblasp.a

# ATLAS
#ATLAS_LIB      := $(HOME_LIB_PATH)/libf77blas.a \
#                  $(HOME_LIB_PATH)/libatlas.a

# Eigen
EIGEN_INC      := $(HOME)/flame/eigen/include/eigen3
EIGEN_LIB      := $(HOME_LIB_PATH)/libeigen_blas_static.a
EIGENP_LIB     := $(EIGEN_LIB)

# MKL
MKL_LIB_PATH   := $(HOME)/intel/mkl/lib/intel64
MKL_LIB        := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_sequential \
                  -lpthread -lm -ldl
#MKLP_LIB       := -L$(MKL_LIB_PATH) \
#                  -lmkl_intel_thread \
#                  -lmkl_core \
#                  -lmkl_intel_ilp64 \
#                  -L$(ICC_LIB_PATH) \
#                  -liomp5
MKLP_LIB       := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_gnu_thread \
                  -lpthread -lm -ldl -fopenmp
                  #-L$(ICC_LIB_PATH) \
                  #-lgomp

VENDOR_LIB     := $(MKL_LIB)
VENDORP_LIB    := $(MKLP_LIB)


#
# --- Problem size definitions -------------------------------------------------
#

# Single core (single-threaded)
PS_BEGIN := 48
PS_MAX   := 2400
PS_INC   := 48

# Single-socket (multithreaded)
P1_BEGIN := 120
P1_MAX   := 6000
P1_INC   := 120

# Dual-socket (multithreaded)
P2_BEGIN := 160
P2_MAX   := 8000
P2_INC   := 160


#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(sort $(patsubst $(TEST_SRC_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(TEST_SRC_PATH)/*.c)))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the "framework" CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS.
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
#LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)

# Define a set of CFLAGS for use with C++ and Eigen.
CXXFLAGS       := $(subst -std=c99,-std=c++11,$(CFLAGS))
CXXFLAGS       += -I$(EIGEN_INC)

# Create a copy of CXXFLAGS without -fopenmp in order to disable multithreading.
CXXFLAGS_ST    := -march=native $(subst -fopenmp,,$(CXXFLAGS))
CXXFLAGS_MT    := -march=native $(CXXFLAGS)


# Which library?
BLI_DEF  := -DBLIS
BLA_DEF  := -DBLAS
EIG_DEF  := -DEIGEN

# Complex implementation type
D3MHW    := -DIND=BLIS_3MH
D3M1     := -DIND=BLIS_3M1
D4MHW    := -DIND=BLIS_4MH
D4M1B    := -DIND=BLIS_4M1B
D4M1A    := -DIND=BLIS_4M1A
D1M      := -DIND=BLIS_1M
DNAT     := -DIND=BLIS_NAT

# Implementation string
#STR_3MHW := -DSTR=\"3mhw\"
#STR_3M1  := -DSTR=\"3m1\"
#STR_4MHW := -DSTR=\"4mhw\"
#STR_4M1B := -DSTR=\"4m1b\"
#STR_4M1A := -DSTR=\"4m1a\"
#STR_1M   := -DSTR=\"1m\"
STR_NAT  := -DSTR=\"asm_blis\"
STR_OBL  := -DSTR=\"openblas\"
STR_EIG  := -DSTR=\"eigen\"
STR_VEN  := -DSTR=\"vendor\"

# Single or multithreaded string
STR_ST   := -DTHR_STR=\"st\"
STR_1S   := -DTHR_STR=\"1s\"
STR_2S   := -DTHR_STR=\"2s\"

# Problem size specification
PDEF_ST  := -DP_BEGIN=$(PS_BEGIN)  -DP_INC=$(PS_INC)  -DP_MAX=$(PS_MAX)
PDEF_1S  := -DP_BEGIN=$(P1_BEGIN) -DP_INC=$(P1_INC) -DP_MAX=$(P1_MAX)
PDEF_2S  := -DP_BEGIN=$(P2_BEGIN) -DP_INC=$(P2_INC) -DP_MAX=$(P2_MAX)



#
# --- Targets/rules ------------------------------------------------------------
#

all:        all-st all-1s all-2s
blis:       blis-st blis-1s blis-2s
openblas:   openblas-st openblas-1s openblas-2s
eigen:      eigen-st eigen-1s eigen-2s
vendor:     vendor-st vendor-1s vendor-2s
mkl:        vendor
armpl:      vendor

all-st:     blis-st openblas-st mkl-st eigen-st
all-1s:     blis-1s openblas-1s mkl-1s eigen-1s
all-2s:     blis-2s openblas-2s mkl-2s eigen-2s

blis-st:    blis-nat-st
blis-1s:    blis-nat-1s
blis-2s:    blis-nat-2s

#blis-ind:   blis-ind-st blis-ind-mt
blis-nat:   blis-nat-st blis-nat-1s blis-nat-2s

# Define the datatypes, operations, and implementations.
DTS    := s d c z
OPS    := gemm hemm herk trmm trsm
BIMPLS := asm_blis openblas vendor
EIMPLS := eigen

# Define functions to construct object filenames from the datatypes and
# operations given an implementation. We define one function for single-
# threaded, single-socket, and dual-socket filenames.
get-st-objs = $(foreach dt,$(DTS),$(foreach op,$(OPS),test_$(dt)$(op)_$(PS_MAX)_$(1)_st.o))
get-1s-objs = $(foreach dt,$(DTS),$(foreach op,$(OPS),test_$(dt)$(op)_$(P1_MAX)_$(1)_1s.o))
get-2s-objs = $(foreach dt,$(DTS),$(foreach op,$(OPS),test_$(dt)$(op)_$(P2_MAX)_$(1)_2s.o))

# Construct object and binary names for single-threaded, single-socket, and
# dual-socket files for BLIS, OpenBLAS, and a vendor library (e.g. MKL).
BLIS_NAT_ST_OBJS := $(call get-st-objs,asm_blis)
BLIS_NAT_ST_BINS := $(patsubst %.o,%.x,$(BLIS_NAT_ST_OBJS))
BLIS_NAT_1S_OBJS := $(call get-1s-objs,asm_blis)
BLIS_NAT_1S_BINS := $(patsubst %.o,%.x,$(BLIS_NAT_1S_OBJS))
BLIS_NAT_2S_OBJS := $(call get-2s-objs,asm_blis)
BLIS_NAT_2S_BINS := $(patsubst %.o,%.x,$(BLIS_NAT_2S_OBJS))

OPENBLAS_ST_OBJS := $(call get-st-objs,openblas)
OPENBLAS_ST_BINS := $(patsubst %.o,%.x,$(OPENBLAS_ST_OBJS))
OPENBLAS_1S_OBJS := $(call get-1s-objs,openblas)
OPENBLAS_1S_BINS := $(patsubst %.o,%.x,$(OPENBLAS_1S_OBJS))
OPENBLAS_2S_OBJS := $(call get-2s-objs,openblas)
OPENBLAS_2S_BINS := $(patsubst %.o,%.x,$(OPENBLAS_2S_OBJS))

EIGEN_ST_OBJS    := $(call get-st-objs,eigen)
EIGEN_ST_BINS    := $(patsubst %.o,%.x,$(EIGEN_ST_OBJS))
EIGEN_1S_OBJS    := $(call get-1s-objs,eigen)
EIGEN_1S_BINS    := $(patsubst %.o,%.x,$(EIGEN_1S_OBJS))
EIGEN_2S_OBJS    := $(call get-2s-objs,eigen)
EIGEN_2S_BINS    := $(patsubst %.o,%.x,$(EIGEN_2S_OBJS))

VENDOR_ST_OBJS   := $(call get-st-objs,vendor)
VENDOR_ST_BINS   := $(patsubst %.o,%.x,$(VENDOR_ST_OBJS))
VENDOR_1S_OBJS   := $(call get-1s-objs,vendor)
VENDOR_1S_BINS   := $(patsubst %.o,%.x,$(VENDOR_1S_OBJS))
VENDOR_2S_OBJS   := $(call get-2s-objs,vendor)
VENDOR_2S_BINS   := $(patsubst %.o,%.x,$(VENDOR_2S_OBJS))

# Define some targets associated with the above object/binary files.
blis-nat-st: check-env $(BLIS_NAT_ST_BINS)
blis-nat-1s: check-env $(BLIS_NAT_1S_BINS)
blis-nat-2s: check-env $(BLIS_NAT_2S_BINS)

openblas-st: check-env $(OPENBLAS_ST_BINS)
openblas-1s: check-env $(OPENBLAS_1S_BINS)
openblas-2s: check-env $(OPENBLAS_2S_BINS)

eigen-st: check-env $(EIGEN_ST_BINS)
eigen-1s: check-env $(EIGEN_1S_BINS)
eigen-2s: check-env $(EIGEN_2S_BINS)

vendor-st: check-env $(VENDOR_ST_BINS)
vendor-1s: check-env $(VENDOR_1S_BINS)
vendor-2s: check-env $(VENDOR_2S_BINS)

mkl-st: vendor-st
mkl-1s: vendor-1s
mkl-2s: vendor-2s

armpl-st: vendor-st
armpl-1s: vendor-1s
armpl-2s: vendor-2s

# Mark the object files as intermediate so that make will remove them
# automatically after building the binaries on which they depend.
.INTERMEDIATE: $(BLIS_NAT_ST_OBJS) $(BLIS_NAT_1S_OBJS) $(BLIS_NAT_2S_OBJS)
.INTERMEDIATE: $(OPENBLAS_ST_OBJS) $(OPENBLAS_1S_OBJS) $(OPENBLAS_2S_OBJS)
.INTERMEDIATE: $(EIGEN_ST_OBJS)    $(EIGEN_1S_OBJS)    $(EIGEN_2S_OBJS)
.INTERMEDIATE: $(VENDOR_ST_OBJS)   $(VENDOR_1S_OBJS)   $(VENDOR_2S_OBJS)


# -- Object file rules --

#$(TEST_OBJ_PATH)/%.o: $(TEST_SRC_PATH)/%.c
#	$(CC) $(CFLAGS) -c $< -o $@

# A function to return the datatype cpp macro def from the datatype
# character.
get-dt-cpp = $(strip \
             $(if $(findstring s,$(1)),-DDT=BLIS_FLOAT    -DIS_FLOAT,\
             $(if $(findstring d,$(1)),-DDT=BLIS_DOUBLE   -DIS_DOUBLE,\
             $(if $(findstring c,$(1)),-DDT=BLIS_SCOMPLEX -DIS_SCOMPLEX,\
                                       -DDT=BLIS_DCOMPLEX -DIS_DCOMPLEX))))

# A function to return other cpp macros that help the test driver
# identify the implementation.
#get-bl-cpp = $(strip \
#             $(if $(findstring     blis,$(1)),$(STR_NAT) $(BLI_DEF),\
#             $(if $(findstring openblas,$(1)),$(STR_OBL) $(BLA_DEF),\
#             $(if $(findstring    eigen,$(1)),$(STR_EIG) $(EIG_DEF),\
#                                              $(STR_VEN) $(BLA_DEF)))))

get-bl-cpp = $(strip \
             $(if $(findstring     blis,$(1)),$(STR_NAT) $(BLI_DEF),\
             $(if $(findstring openblas,$(1)),$(STR_OBL) $(BLA_DEF),\
             $(if $(and $(findstring eigen,$(1)),\
                        $(findstring  gemm,$(2))),\
                                              $(STR_EIG) $(EIG_DEF),\
             $(if       $(findstring eigen,$(1)),\
                                              $(STR_EIG) $(BLA_DEF),\
                                              $(STR_VEN) $(BLA_DEF))))))


# Rules for BLIS and BLAS libraries.
define make-st-rule
test_$(1)$(2)_$(PS_MAX)_$(3)_st.o: test_$(op).c Makefile

=== test/mixeddt/Makefile ===
#!/bin/bash
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
#
# Makefile for standalone BLIS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all all-st all-mt \
        blis blis-st blis-mt \
        blis-nat blis-nat-st blis-nat-mt \
        openblas openblas-st openblas-mt \
        mkl mkl-st mkl-mt \
        blis-gemm-st blis-gemm-mt \
        blis-gemm-nat-st blis-gemm-nat-mt \
        openblas-gemm-st openblas-gemm-mt \
        mkl-gemm-st mkl-gemm-mt \
        clean cleanx



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ../..
LIB_PATH    = ../../lib/$(CONFIG_NAME)
INC_PATH    = ../../include/$(CONFIG_NAME)
SHARE_PATH := ../..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- BLAS and LAPACK implementations ------------------------------------------
#

# BLIS library and header path. This is simply wherever it was installed.
#BLIS_LIB_PATH  := $(INSTALL_PREFIX)/lib
#BLIS_INC_PATH  := $(INSTALL_PREFIX)/include/blis

# BLIS library.
#BLIS_LIB       := $(BLIS_LIB_PATH)/libblis.a

# BLAS library path(s). This is where the BLAS libraries reside.
HOME_LIB_PATH  := $(HOME)/flame/lib



#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(sort $(patsubst $(TEST_SRC_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(TEST_SRC_PATH)/*.c)))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-frame-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the "framework" CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS.
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
#LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)


# Which library?
BLI_DEF  := -DBLIS
BLA_DEF  := -DBLAS

# Single or multithreaded string
STR_ST   := -DTHR_STR=\"st\"
STR_MT   := -DTHR_STR=\"mt\"

# Problem size specification
PDEF_ST  := -DP_BEGIN=40 \
            -DP_MAX=2000 \
            -DP_INC=40

PDEF_MT  := -DP_BEGIN=160 \
            -DP_MAX=8000 \
            -DP_INC=160

# Enumerate possible datatypes and computation precisions.
dts := s d c z
prs := s d

# Various functions that help us construct the datatype combinations and then
# extract the needed datatype strings and C preprocessor define flags.
get-char-c = $(word 1,$(subst _, ,$(1)))
get-char-a = $(word 2,$(subst _, ,$(1)))
get-char-b = $(word 3,$(subst _, ,$(1)))
get-char-x = $(word 4,$(subst _, ,$(1)))
get-cstr   = $(call get-char-c,$(1))$(call get-char-a,$(1))$(call get-char-b,$(1))$(call get-char-x,$(1))

get-cdef-a = $(strip $(subst s,-DDTA=BLIS_FLOAT, \
                     $(subst d,-DDTA=BLIS_DOUBLE, \
                     $(subst c,-DDTA=BLIS_SCOMPLEX, \
                     $(subst z,-DDTA=BLIS_DCOMPLEX,$(call get-char-a,$(1)))))))
get-cdef-b = $(strip $(subst s,-DDTB=BLIS_FLOAT, \
                     $(subst d,-DDTB=BLIS_DOUBLE, \
                     $(subst c,-DDTB=BLIS_SCOMPLEX, \
                     $(subst z,-DDTB=BLIS_DCOMPLEX,$(call get-char-b,$(1)))))))
get-cdef-c = $(strip $(subst s,-DDTC=BLIS_FLOAT, \
                     $(subst d,-DDTC=BLIS_DOUBLE, \
                     $(subst c,-DDTC=BLIS_SCOMPLEX, \
                     $(subst z,-DDTC=BLIS_DCOMPLEX,$(call get-char-c,$(1)))))))
get-cdef-x = $(strip $(subst s,-DDTX=BLIS_FLOAT, \
                     $(subst d,-DDTX=BLIS_DOUBLE,$(call get-char-x,$(1)))))
get-cdefs  = $(call get-cdef-c,$(1)) $(call get-cdef-a,$(1)) $(call get-cdef-b,$(1)) $(call get-cdef-x,$(1))

# Define a function to return the appropriate -DSTR= and -D[BLIS|BLAS] flags.
get-idefs = $(strip $(subst intern,-DSTR=\"$(1)\" -DBLIS, \
                    $(subst ad_hoc,-DSTR=\"$(1)\" -DBLAS, \
                    $(subst    mkl,-DSTR=\"$(1)\" -DBLAS,$(1)))))

# Enumerate all possible datatype combinations.
DT_CODES := $(foreach dt0,$(dts),$(foreach dt1,$(dts),$(foreach dt2,$(dts),$(foreach pr,$(prs),$(dt0)_$(dt1)_$(dt2)_$(pr)))))

# Build a list of the datatype strings.
DT_COMBOS := $(foreach code,$(DT_CODES),$(call get-cstr,$(code)))

# Build a list of BLIS, OpenBLAS, and MKL executables.
INTERN_OBJS_ST := $(foreach combo,$(DT_COMBOS),test_$(combo)gemm_intern_st.o)
INTERN_BINS_ST := $(patsubst %.o,%.x,$(INTERN_OBJS_ST))
AD_HOC_OBJS_ST := $(foreach combo,$(DT_COMBOS),test_$(combo)gemm_ad_hoc_st.o)
AD_HOC_BINS_ST := $(patsubst %.o,%.x,$(AD_HOC_OBJS_ST))

INTERN_OBJS_MT := $(foreach combo,$(DT_COMBOS),test_$(combo)gemm_intern_mt.o)
INTERN_BINS_MT := $(patsubst %.o,%.x,$(INTERN_OBJS_MT))
AD_HOC_OBJS_MT := $(foreach combo,$(DT_COMBOS),test_$(combo)gemm_ad_hoc_mt.o)
AD_HOC_BINS_MT := $(patsubst %.o,%.x,$(AD_HOC_OBJS_MT))



#
# --- Targets/rules ------------------------------------------------------------
#

all:       st

st:        intern-st ad_hoc-st
mt:        intern-mt ad_hoc-mt

intern-st: $(INTERN_BINS_ST)
ad_hoc-st: $(AD_HOC_BINS_ST)
intern-mt: $(INTERN_BINS_MT)
ad_hoc-mt: $(AD_HOC_BINS_MT)

#blis:        test_ssssgemm_asm_blis_st.x \
#             test_sssdgemm_asm_blis_st.x \
#             test_ssdsgemm_asm_blis_st.x \
#             test_sdssgemm_asm_blis_st.x \
#             test_dsssgemm_asm_blis_st.x \
#             test_dddsgemm_asm_blis_st.x \
#             test_ddddgemm_asm_blis_st.x


# --Object file rules --

# Define the function that will be used to instantiate compilation rules
# for the various implementations.
define make-st-rule
test_$(call get-cstr,$(1))gemm_$(2)_st.o: test_gemm.c Makefile
ifeq ($(ENABLE_VERBOSE),yes)
	$(CC) $(CFLAGS) $(PDEF_ST) $(call get-cdefs,$(1)) $(call get-idefs,$(2)) $(STR_ST) -c $$< -o $$@
else
	@echo "Compiling $$@"
	@$(CC) $(CFLAGS) $(PDEF_ST) $(call get-cdefs,$(1)) $(call get-idefs,$(2)) $(STR_ST) -c $$< -o $$@
endif
endef

define make-mt-rule
test_$(call get-cstr,$(1))gemm_$(2)_mt.o: test_gemm.c Makefile
ifeq ($(ENABLE_VERBOSE),yes)
	$(CC) $(CFLAGS) $(PDEF_MT) $(call get-cdefs,$(1)) $(call get-idefs,$(2)) $(STR_MT) -c $$< -o $$@
else
	@echo "Compiling $$@"
	@$(CC) $(CFLAGS) $(PDEF_MT) $(call get-cdefs,$(1)) $(call get-idefs,$(2)) $(STR_MT) -c $$< -o $$@
endif
endef


# Define the implementations for which we will instantiate compilation rules.
IMPLS := intern ad_hoc

# Instantiate the rule function make-st-rule() and make-mt-rule for each
# implementation in IMPLS and each of the datatype "codes" in DT_CODES.
$(foreach impl,$(IMPLS), \
$(foreach code,$(DT_CODES),$(eval $(call make-st-rule,$(code),$(impl)))))

$(foreach impl,$(IMPLS), \
$(foreach code,$(DT_CODES),$(eval $(call make-mt-rule,$(code),$(impl)))))


# -- Executable file rules --

# NOTE: For the BLAS test drivers, we place the BLAS libraries before BLIS
# on the link command line in case BLIS was configured with the BLAS
# compatibility layer. This prevents BLIS from inadvertently getting called
# for the BLAS routines we are trying to test with.

test_%_ad_hoc_st.x: test_%_ad_hoc_st.o $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(LINKER)  $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	$(RM_F) $<
else
	@@echo "Linking $@ to '$(LIBBLIS_LINK)'"
	@$(LINKER) $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	@$(RM_F) $<
endif

test_%_ad_hoc_mt.x: test_%_ad_hoc_mt.o $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(LINKER)  $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	$(RM_F) $<
else
	@@echo "Linking $@ to '$(LIBBLIS_LINK)'"
	@$(LINKER) $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	@$(RM_F) $<
endif


test_%_intern_st.x: test_%_intern_st.o $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(LINKER)  $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	$(RM_F) $<
else
	@@echo "Linking $@ to '$(LIBBLIS_LINK)'"
	@$(LINKER) $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	@$(RM_F) $<
endif

test_%_intern_mt.x: test_%_intern_mt.o $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(LINKER)  $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	$(RM_F) $<
else
	@@echo "Linking $@ to '$(LIBBLIS_LINK)'"
	@$(LINKER) $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	@$(RM_F) $<
endif


# -- Clean rules --

clean: cleanx

cleanx:
	- $(RM_F) *.o *.x

cleanout:
	- $(RM_F) *.m

=== debian/changelog ===
blis (0.8.0-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.
  * Downgrade debhelper compat level to 12.

 -- Mo Zhou <lumin@debian.org>  Tue, 01 Dec 2020 10:35:20 +0800

blis (0.8.0-1) unstable; urgency=medium

  * New upstream version 0.8.0 (Nov 2020)
  * Explicit configurations in descriptions for disambiguity.
  * Refresh patches and symbols control file (amd64).
  * Bump debhelper compat level to 13.

 -- Mo Zhou <lumin@debian.org>  Sun, 22 Nov 2020 09:46:47 +0800

=== debian/control ===
Source: blis
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Nico Schlömer <nico.schloemer@gmail.com>,
           Mo Zhou <lumin@debian.org>,
Section: math
Priority: optional
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/science-team/blis
Vcs-Git: https://salsa.debian.org/science-team/blis.git
Homepage: https://github.com/flame/blis
Build-Depends: debhelper-compat (= 12), python3,
Rules-Requires-Root: no

Package: libblis-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis3 (= ${binary:Version}), ${misc:Depends},
 libblis-openmp-dev | libblis-pthread-dev | libblis-serial-dev,
Description: BLAS-like Library Instantiation Software Framework (dev,32bit,meta)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package pulls development files for one of the 32-bit BlasInt variants.

Package: libblis-openmp-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis3-openmp (= ${binary:Version}), ${misc:Depends}
Provides: libblis.so, libblas.so,
Description: BLAS-like Library Instantiation Software Framework (dev,32bit,openmp)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains (-t openmp) version of development files.

Package: libblis-pthread-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis3-pthread (= ${binary:Version}), ${misc:Depends}
Provides: libblis.so, libblas.so,
Description: BLAS-like Library Instantiation Software Framework (dev,32bit,pthread)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains (-t pthread) version of development files.

Package: libblis-serial-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis3-serial (= ${binary:Version}), ${misc:Depends}
Provides: libblis.so, libblas.so,
Description: BLAS-like Library Instantiation Software Framework (dev,32bit,serial)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains (-t no) version development files.

Package: libblis3
Architecture: any
Multi-Arch: same
Section: metapackages
Depends: ${misc:Depends}, ${shlibs:Depends},
  libblis3-openmp (= ${binary:Version})
  | libblis3-pthread (= ${binary:Version})
  | libblis3-serial (= ${binary:Version}),
Description: BLAS-like Library Instantiation Software Framework (32bit,meta)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package pulls one of the 32-bit-BlasInt shared library variants.

Package: libblis3-openmp
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Provides: libblis.so.2, libblas.so.3,
Breaks: libblis2-openmp
Replaces: libblis2-openmp
Description: BLAS-like Library Instantiation Software Framework (32bit,openmp)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the (-t openmp) version of shared library.

Package: libblis3-pthread
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Provides: libblis.so.2, libblas.so.3,
Breaks: libblis2-pthread
Replaces: libblis2-pthread
Description: BLAS-like Library Instantiation Software Framework (32bit,pthread)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the (-t pthread) version of shared library.

Package: libblis3-serial
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Provides: libblis.so.2, libblas.so.3,
Breaks: libblis2-serial
Replaces: libblis2-serial
Description: BLAS-like Library Instantiation Software Framework (32bit,serial)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the (-t no) version of shared library.

Package: libblis64-dev
Architecture: amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64
Multi-Arch: same
Section: libdevel
Depends: libblis64-3 (= ${binary:Version}), ${misc:Depends},
 libblis64-openmp-dev | libblis64-pthread-dev | libblis64-serial-dev,
Description: BLAS-like Library Instantiation Software Framework (dev,64bit,meta)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package pulls development files for one of the 64-bit BlasInt variants.

Package: libblis64-openmp-dev
Architecture: amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64
Multi-Arch: same
Section: libdevel
Depends: libblis64-3-openmp (= ${binary:Version}), ${misc:Depends}
Provides: libblis64.so, libblas64.so,
Description: BLAS-like Library Instantiation Software Framework (dev,64bit,openmp)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the (-b 64 -i 64 -t openmp) version of development files.

Package: libblis64-pthread-dev
Architecture: amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64
Multi-Arch: same
Section: libdevel
Depends: libblis64-3-pthread (= ${binary:Version}), ${misc:Depends}
Provides: libblis64.so, libblas64.so,
Description: BLAS-like Library Instantiation Software Framework (dev,64bit,pthread)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the (-b 64 -i 64 -t pthread) version of development files.

Package: libblis64-serial-dev
